import 'dart:async';

import 'package:flutter/services.dart';
import 'dart:convert';

class NotificationEvent {
  Map<String,Object> _msg;

  NotificationEvent(String sevent) {
    this._msg=json.decode(sevent);
    this._msg["timestamp"]=DateTime.now();
  }

  Map<String,Object> get Msg => _msg;

  @override
  String toString() {
    return "[$Msg sent notification @ $Msg['timestamp']";
  }
}

NotificationEvent _notificationEvent(String event) {
  return new NotificationEvent(event);
}

class Notifications {
  static const EventChannel _notificationEventChannel =
      EventChannel('notifications.eventChannel');

  Stream<NotificationEvent> _notificationStream;

  Stream<NotificationEvent> get stream {
    if (_notificationStream == null) {
      _notificationStream = _notificationEventChannel
          .receiveBroadcastStream()
          .map((event) => _notificationEvent(event));
    }
    return _notificationStream;
  }
}
